/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2000, 2010 Oracle and/or its affiliates.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifndef SC_SCCOMMANDS_HRC
#define SC_SCCOMMANDS_HRC

#define CMD_FID_CHG_ACCEPT                          ".uno:AcceptChanges"
#define CMD_SID_OLE_ACTIVATE                        ".uno:ActivateOLE"
#define CMD_SID_TABLE_ACTIVATE                      ".uno:ActivateTable"
#define CMD_SID_SC_ACTIVECELL                       ".uno:ActiveCell"
#define CMD_SID_SC_ACTIVETAB                        ".uno:ActiveTable"
#define CMD_FID_TAB_APPEND                          ".uno:Add"
#define CMD_SID_CHART_ADDSOURCE                     ".uno:AddChartData"
#define CMD_SID_ADD_IN_MANAGER                      ".uno:AddInManager"
#define CMD_SID_ADD_PRINTAREA                       ".uno:AddPrintArea"
#define CMD_SID_RANGE_ADDRESS                       ".uno:Address"
#define CMD_FID_ADJUST_PRINTZOOM                    ".uno:AdjustPrintZoom"
#define CMD_SID_ALIGNBLOCK                          ".uno:AlignBlock"
#define CMD_SID_ALIGNBOTTOM                         ".uno:AlignBottom"
#define CMD_SID_ALIGNCENTERHOR                      ".uno:AlignHorizontalCenter"
#define CMD_SID_ALIGNLEFT                           ".uno:AlignLeft"
#define CMD_SID_ALIGNRIGHT                          ".uno:AlignRight"
#define CMD_SID_ALIGNTOP                            ".uno:AlignTop"
#define CMD_SID_ALIGNCENTERVER                      ".uno:AlignVCenter"
#define CMD_FID_APPLY_NAME                          ".uno:ApplyNames"
#define CMD_SID_DETECTIVE_FILLMODE                  ".uno:AuditingFillMode"
#define CMD_FID_AUTOCOMPLETE                        ".uno:AutoComplete"
#define CMD_FID_FILL_AUTO                           ".uno:AutoFill"
#define CMD_FID_AUTO_CALC                           ".uno:AutomaticCalculation"
#define CMD_SID_AUTO_OUTLINE                        ".uno:AutoOutline"
#define CMD_SID_DETECTIVE_AUTO                      ".uno:AutoRefreshArrows"
#define CMD_SID_AUTO_STYLE                          ".uno:AutoStyle"
#define CMD_FID_RECALC                              ".uno:Calculate"
#define CMD_FID_HARD_RECALC                         ".uno:CalculateHard"
#define CMD_SID_CANCEL                              ".uno:Cancel"
#define CMD_SID_SC_CELLS                            ".uno:Cells"
#define CMD_SID_SC_CELLTEXT                         ".uno:CellText"
#define CMD_SID_CHART_SOURCE                        ".uno:ChangeChartData"
#define CMD_SID_CHANGE_PRINTAREA                    ".uno:ChangePrintArea"
#define CMD_SID_CHOOSE_DESIGN                       ".uno:ChooseDesign"
#define CMD_SID_DETECTIVE_DEL_SUCC                  ".uno:ClearArrowDependents"
#define CMD_SID_DETECTIVE_DEL_PRED                  ".uno:ClearArrowPrecedents"
#define CMD_SID_DETECTIVE_DEL_ALL                   ".uno:ClearArrows"
#define CMD_SID_DELETE_CONTENTS                     ".uno:ClearContents"
#define CMD_SID_RANGE_COL                           ".uno:Column"
#define CMD_FID_COL_WIDTH                           ".uno:ColumnWidth"
#define CMD_FID_CHG_COMMENT                         ".uno:CommentChange"
#define CMD_FID_CONDITIONAL_FORMAT                  ".uno:ConditionalFormat"
#define CMD_SID_OPENDLG_CONDFRMT                    ".uno:ConditionalFormatDialog"
#define CMD_SID_CONSOLIDATE                         ".uno:ConsolidateExec"
#define CMD_FID_USE_NAME                            ".uno:CreateNames"
#define CMD_SID_CREATE_SW_DRAWVIEW                  ".uno:CreateSWDrawView"
#define CMD_SID_RANGE_REGION                        ".uno:CurrentRegion"
#define CMD_SID_REFRESH_DBAREA                      ".uno:DataAreaRefresh"
#define CMD_SID_OPENDLG_CONSOLIDATE                 ".uno:DataConsolidate"
#define CMD_SID_OPENDLG_PIVOTTABLE                  ".uno:DataDataPilotRun"
#define CMD_SID_AUTO_FILTER                         ".uno:DataFilterAutoFilter"
#define CMD_SID_AUTOFILTER_HIDE                     ".uno:DataFilterHideAutoFilter"
#define CMD_SID_UNFILTER                            ".uno:DataFilterRemoveFilter"
#define CMD_SID_SPECIAL_FILTER                      ".uno:DataFilterSpecialFilter"
#define CMD_SID_FILTER                              ".uno:DataFilterStandardFilter"
#define CMD_SID_IMPORT_DATA                         ".uno:DataImport"
#define CMD_SID_PIVOT_CREATE                        ".uno:DataPilotCreate"
#define CMD_SID_PIVOT_TABLE                         ".uno:DataPilotExec"
#define CMD_SID_PIVOT_GET                           ".uno:DataPilotTables"
#define CMD_SID_REIMPORT_DATA                       ".uno:DataReImport"
#define CMD_SID_DATA_SELECT                         ".uno:DataSelect"
#define CMD_SID_SORT                                ".uno:DataSort"
#define CMD_SID_SUBTOTALS                           ".uno:DataSubTotals"
#define CMD_SID_OLE_DEACTIVATE                      ".uno:Deactivate"
#define CMD_SID_DEFINE_DBNAME                       ".uno:DefineDBName"
#define CMD_SID_DEFINE_COLROWNAMERANGES             ".uno:DefineLabelRange"
#define CMD_FID_DEFINE_NAME                         ".uno:DefineName"
#define CMD_SID_DEFINE_PRINTAREA                    ".uno:DefinePrintArea"
#define CMD_FID_DELETE_CELL                         ".uno:DeleteCell"
#define CMD_FID_DEL_MANUALBREAKS                    ".uno:DeleteAllBreaks"
#define CMD_FID_DEL_COLBRK                          ".uno:DeleteColumnbreak"
#define CMD_SID_DEL_COLS                            ".uno:DeleteColumns"
#define CMD_SID_PIVOT_KILL                          ".uno:DeletePivotTable"
#define CMD_SID_DELETE_PRINTAREA                    ".uno:DeletePrintArea"
#define CMD_FID_DEL_ROWBRK                          ".uno:DeleteRowbreak"
#define CMD_SID_DEL_ROWS                            ".uno:DeleteRows"
#define CMD_SID_DELETE_SCENARIO                     ".uno:DeleteScenario"
#define CMD_SID_SELECT_NONE                         ".uno:Deselect"
#define CMD_SID_DRAW_CHART                          ".uno:DrawChart"
#define CMD_SID_DRAW_NOTEEDIT                       ".uno:DrawEditNote"
#define CMD_SID_HFEDIT                              ".uno:EditHeaderAndFooter"
#define CMD_SID_LINKS                               ".uno:EditLinks"
#define CMD_SID_SC_EDIT_OBJECT                      ".uno:EditObject"
#define CMD_SID_OPENDLG_EDIT_PRINTAREA              ".uno:EditPrintArea"
#define CMD_SID_EDIT_SCENARIO                       ".uno:EditScenario"
#define CMD_SID_EURO_CONVERTER                      ".uno:EuroConverter"
#define CMD_FID_FILL_TO_BOTTOM                      ".uno:FillDown"
#define CMD_FID_FILL_TO_LEFT                        ".uno:FillLeft"
#define CMD_SID_FILL_NONE                           ".uno:FillModeEnd"
#define CMD_SID_FILL_DEL_PRED                       ".uno:FillModeRemovePredescessor"
#define CMD_SID_FILL_DEL_SUCC                       ".uno:FillModeRemoveSuccessor"
#define CMD_SID_FILL_SELECT                         ".uno:FillModeSelect"
#define CMD_SID_FILL_ADD_PRED                       ".uno:FillModeTracePredescessor"
#define CMD_SID_FILL_ADD_SUCC                       ".uno:FillModeTraceSuccessor"
#define CMD_FID_FILL_TO_RIGHT                       ".uno:FillRight"
#define CMD_FID_FILL_SERIES                         ".uno:FillSeries"
#define CMD_FID_FILL_TAB                            ".uno:FillTable"
#define CMD_FID_FILL_TO_TOP                         ".uno:FillUp"
#define CMD_FID_FILTER_OK                           ".uno:FilterExecute"
#define CMD_SID_PREVIEW_FIRST                       ".uno:FirstPage"
#define CMD_FID_FOCUS_POSWND                        ".uno:FocusCellAddress"
#define CMD_FID_CELL_FORMAT                         ".uno:FormatCellDialog"
#define CMD_SID_RANGE_FORMULA                       ".uno:Formula"
#define CMD_SID_WINDOW_FIX                          ".uno:FreezePanes"
#define CMD_FID_FUNCTION_BOX                        ".uno:FunctionBox"
#define CMD_SID_OPENDLG_FUNCTION                    ".uno:FunctionDialog"
#define CMD_SID_SOLVE                               ".uno:GoalSeek"
#define CMD_SID_OPENDLG_SOLVE                       ".uno:GoalSeekDialog"
#define CMD_SID_OPENDLG_OPTSOLVER                   ".uno:SolverDialog"
#define CMD_SID_VALIDITY_REFERENCE                  ".uno:ValidityReference"
#define CMD_SID_CURSORBLKDOWN                       ".uno:GoDownToEndOfData"
#define CMD_SID_CURSORBLKDOWN_SEL                   ".uno:GoDownToEndOfDataSel"
#define CMD_SID_CURSORPAGELEFT_                     ".uno:GoLeftBlock"
#define CMD_SID_CURSORBLKLEFT                       ".uno:GoLeftToStartOfData"
#define CMD_SID_CURSORBLKLEFT_SEL                   ".uno:GoLeftToStartOfDataSel"
#define CMD_SID_CURSORPAGERIGHT_                    ".uno:GoRightBlock"
#define CMD_SID_CURSORPAGERIGHT_SEL                 ".uno:GoRightBlockSel"
#define CMD_SID_CURSORBLKRIGHT                      ".uno:GoRightToEndOfData"
#define CMD_SID_CURSORBLKRIGHT_SEL                  ".uno:GoRightToEndOfDataSel"
#define CMD_SID_CURRENTCELL                         ".uno:GoToCell"
#define CMD_SID_ALIGNCURSOR                         ".uno:GoToCurrentCell"
#define CMD_SID_CURRENTDOC                          ".uno:GotoDocument"
#define CMD_SID_CURRENTOBJECT                       ".uno:GoToObject"
#define CMD_SID_CURSORBLKUP                         ".uno:GoUpToStartOfData"
#define CMD_SID_CURSORBLKUP_SEL                     ".uno:GoUpToStartOfDataSel"
#define CMD_FID_TABLE_HIDE                          ".uno:Hide"
#define CMD_FID_COL_HIDE                            ".uno:HideColumn"
#define CMD_FID_ROW_HIDE                            ".uno:HideRow"
#define CMD_SID_H_ALIGNCELL                         ".uno:HorizontalAlignment"
#define CMD_SID_ENABLE_HYPHENATION                  ".uno:Hyphenate"
#define CMD_FID_INPUTLINE_BLOCK                     ".uno:InputLineBlock"
#define CMD_FID_INPUTLINE_ENTER                     ".uno:InputLineEnter"
#define CMD_FID_INPUTLINE_MATRIX                    ".uno:InputLineMatrix"
#define CMD_SID_TBXCTL_INSCELLS                     ".uno:InsCellsCtrl"
#define CMD_FID_INS_TABLE                           ".uno:Insert"
#define CMD_FID_INS_TABLE_EXT                       ".uno:InsertSheetFromFile"
#define CMD_FID_INS_CELL                            ".uno:InsertCell"
#define CMD_FID_INS_CELLSDOWN                       ".uno:InsertCellsDown"
#define CMD_FID_INS_CELLSRIGHT                      ".uno:InsertCellsRight"
#define CMD_FID_INS_COLBRK                          ".uno:InsertColumnBreak"
#define CMD_FID_INS_COLUMN                          ".uno:InsertColumns"
#define CMD_FID_INS_CELL_CONTENTS                   ".uno:InsertContents"
#define CMD_SID_TBXCTL_INSERT                       ".uno:InsertCtrl"
#define CMD_SID_EXTERNAL_SOURCE                     ".uno:InsertExternalDataSource"
#define CMD_FID_INSERT_FILE                         ".uno:InsertFile"
#define CMD_SID_INS_FUNCTION                        ".uno:InsertFunction"
#define CMD_SID_INSERT_MATRIX                       ".uno:InsertMatrix"
#define CMD_FID_INSERT_NAME                         ".uno:InsertName"
#define CMD_SID_INSERT_SIMAGE                       ".uno:InsertObjectStarImage"
#define CMD_SID_INSERT_SMATH                        ".uno:InsertObjectStarMath"
#define CMD_FID_INS_ROWBRK                          ".uno:InsertRowBreak"
#define CMD_FID_INS_ROW                             ".uno:InsertRows"
#define CMD_SID_TBXCTL_INSOBJ                       ".uno:InsObjCtrl"
#define CMD_SID_CURSORENTERDOWN                     ".uno:JumpToNextCell"
#define CMD_SID_NEXT_TABLE                          ".uno:JumpToNextTable"
#define CMD_SID_NEXT_TABLE_SEL                      ".uno:JumpToNextTableSel"
#define CMD_SID_NEXT_UNPROTECT                      ".uno:JumpToNextUnprotected"
#define CMD_SID_CURSORENTERUP                       ".uno:JumpToPreviousCell"
#define CMD_SID_PREV_UNPROTECT                      ".uno:JumpToPreviousUnprotected"
#define CMD_SID_PREV_TABLE                          ".uno:JumpToPrevTable"
#define CMD_SID_PREV_TABLE_SEL                      ".uno:JumpToPrevTableSel"
#define CMD_SID_CURRENTTAB                          ".uno:JumpToTable"
#define CMD_SID_PREVIEW_LAST                        ".uno:LastPage"
#define CMD_FID_MERGE_ON                            ".uno:MergeCells"
#define CMD_FID_MERGE_TOGGLE                        ".uno:ToggleMergeCells"
#define CMD_SID_OBJECT_MIRROR                       ".uno:Mirror"
#define CMD_FID_TAB_MOVE                            ".uno:Move"
#define CMD_FID_TAB_RENAME                          ".uno:Name"
#define CMD_SID_PREVIEW_NEXT                        ".uno:NextPage"
#define CMD_SID_RANGE_NOTETEXT                      ".uno:NoteText"
#define CMD_FID_NOTE_VISIBLE                        ".uno:NoteVisible"
#define CMD_SID_DELETE_NOTE                         ".uno:DeleteNote"
#define CMD_SID_NUMBER_FORMAT                       ".uno:NumberFormat"
#define CMD_SID_NUMBER_CURRENCY                     ".uno:NumberFormatCurrency"
#define CMD_SID_NUMBER_DATE                         ".uno:NumberFormatDate"
#define CMD_SID_NUMBER_DECDEC                       ".uno:NumberFormatDecDecimals"
#define CMD_SID_NUMBER_TWODEC                       ".uno:NumberFormatDecimal"
#define CMD_SID_NUMBER_INCDEC                       ".uno:NumberFormatIncDecimals"
#define CMD_SID_NUMBER_PERCENT                      ".uno:NumberFormatPercent"
#define CMD_SID_NUMBER_SCIENTIFIC                   ".uno:NumberFormatScientific"
#define CMD_SID_NUMBER_STANDARD                     ".uno:NumberFormatStandard"
#define CMD_SID_NUMBER_TIME                         ".uno:NumberFormatTime"
#define CMD_SID_OBJECT_HEIGHT                       ".uno:ObjectHeight"
#define CMD_SID_OBJECT_LEFT                         ".uno:ObjectLeft"
#define CMD_SID_MIRROR_HORIZONTAL                   ".uno:ObjectMirrorHorizontal"
#define CMD_SID_MIRROR_VERTICAL                     ".uno:ObjectMirrorVertical"
#define CMD_SID_OBJECT_TOP                          ".uno:ObjectTop"
#define CMD_SID_OBJECT_WIDTH                        ".uno:ObjectWidth"
#define CMD_SID_RANGE_OFFSET                        ".uno:Offset"
#define CMD_SID_OLE_OBJECT                          ".uno:OleObject"
#define CMD_SID_ORIGINALSIZE                        ".uno:OriginalSize"
#define CMD_FID_NORMALVIEWMODE                      ".uno:NormalViewMode"
#define CMD_FID_PAGEBREAKMODE                       ".uno:PagebreakMode"
#define CMD_SID_FORMATPAGE                          ".uno:PageFormatDialog"
#define CMD_SID_PREVIEW_PREVIOUS                    ".uno:PreviousPage"
#define CMD_FID_PROTECT_TABLE                       ".uno:Protect"
#define CMD_SID_CHG_PROTECT                         ".uno:ProtectTraceChangeMode"
#define CMD_SID_SC_SETTEXT                          ".uno:PutCell"
#define CMD_SID_SC_RANGE                            ".uno:Range"
#define CMD_SID_PIVOT_RECALC                        ".uno:RecalcPivotTable"
#define CMD_SID_DETECTIVE_REFRESH                   ".uno:RefreshArrows"
#define CMD_SID_REIMPORT_AFTER_LOAD                 ".uno:ReImportAfterLoad"
#define CMD_FID_DELETE_TABLE                        ".uno:Remove"
#define CMD_SID_TITLE_DESCRIPTION_OBJECT            ".uno:ObjectTitleDescription"
#define CMD_SID_RENAME_OBJECT                       ".uno:RenameObject"
#define CMD_FID_REPEAT_SEARCH                       ".uno:RepeatSearch"
#define CMD_FID_REPLACE                             ".uno:Replace"
#define CMD_FID_REPLACE_ALL                         ".uno:ReplaceAll"
#define CMD_SID_CELL_FORMAT_RESET                   ".uno:ResetAttributes"
#define CMD_FID_RESET_PRINTZOOM                     ".uno:ResetPrintZoom"
#define CMD_SID_RANGE_ROW                           ".uno:Row"
#define CMD_FID_ROW_HEIGHT                          ".uno:RowHeight"
#define CMD_SID_SBA_IMPORT                          ".uno:SbaImport"
#define CMD_FID_SCALE                               ".uno:Scale"
#define CMD_SID_SCENARIOS                           ".uno:ScenarioManager"
#define CMD_FID_SEARCH                              ".uno:Search"
#define CMD_FID_SEARCH_ALL                          ".uno:SearchAll"
#define CMD_SID_MARKAREA                            ".uno:SelectArea"
#define CMD_SID_OLE_SELECT                          ".uno:SelectOLE"
#define CMD_SID_SELECT_COL                          ".uno:SelectColumn"
#define CMD_SID_MARKDATAAREA                        ".uno:SelectData"
#define CMD_SID_SELECT_DB                           ".uno:SelectDB"
#define CMD_SID_SC_ACTIVEOBJECT                     ".uno:SelectedObject"
#define CMD_SID_ACTIVE_OBJ_NAME                     ".uno:SelectedObjectName"
#define CMD_SID_SC_SELECTION                        ".uno:Selection"
#define CMD_SID_SELECT_ROW                          ".uno:SelectRow"
#define CMD_SID_SELECT_SCENARIO                     ".uno:SelectScenario"
#define CMD_SID_ANCHOR_CELL                         ".uno:SetAnchorToCell"
#define CMD_SID_ANCHOR_PAGE                         ".uno:SetAnchorToPage"
#define CMD_SID_SETINPUTMODE                        ".uno:SetInputMode"
#define CMD_FID_COL_OPT_WIDTH                       ".uno:SetOptimalColumnWidth"
#define CMD_FID_COL_OPT_DIRECT                      ".uno:SetOptimalColumnWidthDirect"
#define CMD_FID_ROW_OPT_HEIGHT                      ".uno:SetOptimalRowHeight"
#define CMD_FID_TABLE_SHOW                          ".uno:Show"
#define CMD_FID_CHG_SHOW                            ".uno:ShowChanges"
#define CMD_FID_COL_SHOW                            ".uno:ShowColumn"
#define CMD_SID_DETECTIVE_ADD_SUCC                  ".uno:ShowDependents"
#define CMD_SID_DETECTIVE_ADD_ERR                   ".uno:ShowErrors"
#define CMD_SID_DETECTIVE_INVALID                   ".uno:ShowInvalid"
#define CMD_SID_DETECTIVE_ADD_PRED                  ".uno:ShowPrecedents"
#define CMD_FID_ROW_SHOW                            ".uno:ShowRow"
#define CMD_WID_SIMPLE_REF                          ".uno:SimpleReferenz"
#define CMD_SID_SORT_ASCENDING                      ".uno:SortAscending"
#define CMD_SID_SORT_DESCENDING                     ".uno:SortDescending"
#define CMD_FID_MERGE_OFF                           ".uno:SplitCell"
#define CMD_SID_WINDOW_SPLIT                        ".uno:SplitWindow"
#define CMD_SID_STANDARD_FONTS                      ".uno:StandardFonts"
#define CMD_SID_TEXT_STANDARD                       ".uno:StandardTextAttributes"
#define CMD_SID_PSZ_FUNCTION                        ".uno:StatusBarFunc"
#define CMD_SID_STATUS_DOCPOS                       ".uno:StatusDocPos"
#define CMD_SID_STATUS_SUM                          ".uno:StatusFunction"
#define CMD_FID_INPUTLINE_STATUS                    ".uno:StatusInputLine"
#define CMD_SID_STATUS_PAGESTYLE                    ".uno:StatusPageStyle"
#define CMD_FID_SCALESTATUS                         ".uno:StatusScale"
#define CMD_SID_STATUS_SELMODE                      ".uno:StatusSelectionMode"
#define CMD_SID_STATUS_SELMODE_ERG                  ".uno:StatusSelectionModeExp"
#define CMD_SID_STATUS_SELMODE_ERW                  ".uno:StatusSelectionModeExt"
#define CMD_SID_STATUS_SELMODE_NORM                 ".uno:StatusSelectionModeNorm"
#define CMD_SID_RANGE_TABLE                         ".uno:Table"
#define CMD_SID_TABLES_COUNT                        ".uno:TableCount"
#define CMD_SID_TABOP                               ".uno:TableOperation"
#define CMD_SID_OPENDLG_TABOP                       ".uno:TableOperationDialog"
#define CMD_FID_TAB_MENU_RENAME                     ".uno:RenameTable"
#define CMD_SID_TABLES_GET                          ".uno:Tables"
#define CMD_FID_TAB_SELECTALL                       ".uno:TableSelectAll"
#define CMD_FID_TAB_DESELECTALL                     ".uno:TableDeselectAll"
#define CMD_SID_DRAWTEXT_ATTR_DLG                   ".uno:TextAttributes"
#define CMD_SID_ASSIGNMACRO                         ".uno:AssignMacro"
#define CMD_SID_TEXT_TO_COLUMNS                     ".uno:TextToColumns"
#define CMD_SID_RANGE_TEXTVALUE                     ".uno:TextValue"
#define CMD_SID_ANCHOR_TOGGLE                       ".uno:ToggleAnchorType"
#define CMD_SID_TOGGLE_REL                          ".uno:ToggleRelative"
#define CMD_FID_PROTECT_DOC                         ".uno:ToolProtectionDocument"
#define CMD_SID_SCOPTIONS                           ".uno:ToolsOptions"
#define CMD_FID_CHG_RECORD                          ".uno:TraceChangeMode"
#define CMD_SID_ULINE_VAL_DOTTED                    ".uno:UnderlineDotted"
#define CMD_SID_ULINE_VAL_DOUBLE                    ".uno:UnderlineDouble"
#define CMD_SID_ULINE_VAL_NONE                      ".uno:UnderlineNone"
#define CMD_SID_ULINE_VAL_SINGLE                    ".uno:UnderlineSingle"
#define CMD_SID_UPDATECHART                         ".uno:UpdateChart"
#define CMD_SID_UPDATETABLINKS                      ".uno:UpdateTableLinks"
#define CMD_FID_VALIDATION                          ".uno:Validation"
#define CMD_SID_RANGE_VALUE                         ".uno:Value"
#define CMD_SID_V_ALIGNCELL                         ".uno:VerticalAlignment"
#define CMD_FID_TOGGLEINPUTLINE                     ".uno:InputLineVisible"
#define CMD_FID_TOGGLEHEADERS                       ".uno:ViewRowColumnHeaders"
#define CMD_FID_TOGGLEFORMULA                       ".uno:ToggleFormula"
#define CMD_FID_TOGGLESYNTAX                        ".uno:ViewValueHighlighting"
#define CMD_FID_TABLE_VISIBLE                       ".uno:Visible"
#define CMD_SID_ATTR_ALIGN_LINEBREAK                ".uno:WrapText"
#define CMD_SID_PREVIEW_ZOOMIN                      ".uno:ZoomIn"
#define CMD_SID_PREVIEW_ZOOMOUT                     ".uno:ZoomOut"
#define CMD_SID_FOCUS_INPUTLINE                     ".uno:FocusInputLine"
#define CMD_SID_PREVIEW_CLOSE                       ".uno:ClosePreview"
#define CMD_SID_PREVIEW_MARGIN                      ".uno:Margins"
#define CMD_SID_PREVIEW_SCALINGFACTOR               ".uno:ScalingFactor"
#define CMD_SID_SELECT_TABLES                       ".uno:SelectTables"
#define CMD_SID_DP_FILTER                           ".uno:DataPilotFilter"
#define CMD_SID_SCATTR_PROTECTION                   ".uno:Protection"
#define CMD_SID_MARKARRAYFORMULA                    ".uno:SelectArrayFormula"
#define CMD_FID_TAB_RTL                             ".uno:SheetRightToLeft"
#define CMD_SID_SHARE_DOC                           ".uno:ShareDocument"
#define CMD_FID_TAB_EVENTS                          ".uno:TableEvents"
#define CMD_FID_TAB_MENU_SET_TAB_BG_COLOR           ".uno:SetTabBgColor"
#define CMD_FID_TAB_SET_TAB_BG_COLOR                ".uno:TabBgColor"

#endif
