/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2000, 2010 Oracle and/or its affiliates.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/

#ifndef SC_FORMATSH_HXX
#define SC_FORMATSH_HXX

#include <sfx2/shell.hxx>
#include "shellids.hxx"
#include <sfx2/module.hxx>
#include <svx/svdmark.hxx>

class ScViewData;

class ScFormatShell: public SfxShell
{
    ScViewData* pViewData;

protected:

    ScViewData*			GetViewData(){return pViewData;}
    const ScViewData*   GetViewData() const {return pViewData;}

public:

    TYPEINFO();
    SFX_DECL_INTERFACE(SCID_FORMAT_SHELL)

                ScFormatShell(ScViewData* pData);
    virtual		~ScFormatShell();

    void		ExecuteNumFormat( SfxRequest& rReq );
    void		GetNumFormatState( SfxItemSet& rSet );

    void		ExecuteAttr( SfxRequest& rReq );
    void		GetAttrState( SfxItemSet& rSet );

    void		ExecuteAlignment( SfxRequest& rReq );

    void		ExecuteTextAttr( SfxRequest& rReq );
    void		GetTextAttrState( SfxItemSet& rSet );

    void		GetAlignState( SfxItemSet& rSet );
    void		GetBorderState( SfxItemSet& rSet );

    void		ExecuteStyle( SfxRequest& rReq );
    void		GetStyleState( SfxItemSet& rSet );

    void        ExecuteTextDirection( SfxRequest& rReq );
    void        GetTextDirectionState( SfxItemSet& rSet );

    void        ExecFormatPaintbrush( SfxRequest& rReq );
    void        StateFormatPaintbrush( SfxItemSet& rSet );

private:
    short       GetCurrentNumberFormatType();
};

#endif

/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
